<?php
/***************************************************************************
 *                                 search.php
 *                            -------------------
 *   begin                : Tuesday', Aug 15', 2002
 *   copyright            : ('C) 2009 phpATM Dev Team
 *   email                : flavaclown.de/contact.php
 *
 *   $Id: search.php, v1.32 03/12/2009 23:06 Flava Clown $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPATM', true);
$include_location = dirname($_SERVER['SCRIPT_FILENAME'])."/";
include($include_location.'include/conf.php');
include($include_location.'include/common.'.$phpExt);

// Stampa la parte superiore dell'upload, comprensiva di titolo principale,
// titolo sezione, status bar e icone controlli utenti
function place_header($message)
{
	place_message('', $message, basename(__FILE__));
}

function findfile_byfilename($location='',$fileregex='')
{
	global $rejectedfiles, $grants, $user_status, $validation_enabled, $logged_user_name, $reserved_files;

	if (!$location || !is_dir($location) || !$fileregex)
	{
		return false;
	}

	$matchedfiles = array();

	$all = opendir($location);
	while ($filename = readdir($all))
	{
		if (is_dir("$location/$filename") && ($filename != "..") && ($filename != ".") && show_hidden_files($filename))
		{
			$subdir_matches = findfile_byfilename("$location/$filename",$fileregex);
			$matchedfiles = array_merge($matchedfiles,$subdir_matches);
			unset($filename);
		}
		elseif (!is_dir("$location/$filename"))
		{
			$fileregex = str_replace("\*", " " , $fileregex);
			if ((preg_match($fileregex,$filename)) && (!eregi($rejectedfiles, $filename)) && (!eregi($reserved_files, $filename)))
			{
				// Load description
				list($upl_user, , $filestatus) = get_file_description($filename, $comment_max_caracters);
				
				if(!$validation_enabled || $filestatus == VALIDATED || $upl_user == $logged_user_name || ($filestatus == UNVALIDATED && $grants[$user_status][VALIDATE]))
				{ array_push($matchedfiles,"$location/$filename"); }
			}
		}
	}
	closedir($all);
	unset($all);
	return $matchedfiles;
}

function findfile_byauthor($location='', $fileregex='')
{
	global $rejectedfiles, $comment_max_caracters, $grants, $user_status, $validation_enabled, $logged_user_name,$reserved_files;

	if (!$location || !is_dir($location) || !$fileregex)
	{
		return false;
	}

	$matchedfiles = array();

	$all = opendir($location);
	while ($filename = readdir($all))
	{
		if (is_dir("$location/$filename") && ($filename != "..") && ($filename != ".") && show_hidden_files($filename))
		{
			$subdir_matches = findfile_byauthor("$location/$filename", $fileregex);
			$matchedfiles = array_merge($matchedfiles, $subdir_matches);
			unset($filename);
		}
		elseif (!is_dir("$location/$filename"))
		{
			list($upl_user) = get_file_description("$location/$filename", $comment_max_caracters);
			$fileregex = str_replace("\*", " " , $fileregex);
			if ( (preg_match($fileregex,$upl_user)) && (!eregi($rejectedfiles, $filename)) && (!eregi($reserved_files, $filename)) )
			{
				// Load description
				list($upl_user, , $filestatus) = get_file_description($filename, $comment_max_caracters);
				
				if(!$validation_enabled || $filestatus == VALIDATED || $upl_user == $logged_user_name || ($filestatus == UNVALIDATED && $grants[$user_status][VALIDATE]))
				{ array_push($matchedfiles,"$location/$filename"); }
			}
		}
	}
	closedir($all);
	unset($all);
	return $matchedfiles;
}

function findfile_bydesc($location='', $fileregex='')
{
	global $rejectedfiles, $comment_max_caracters, $contents, $grants, $user_status, $validation_enabled, $logged_user_name,$reserved_files;

	if (!$location || !is_dir($location) || !$fileregex)
	{
		return false;
	}

	$matchedfiles = array();

	$all = opendir($location);
	while ($filename = readdir($all))
	{
		if (is_dir("$location/$filename") && ($filename != "..") && ($filename != ".") && show_hidden_files($filename))
		{
			$subdir_matches = findfile_bydesc("$location/$filename", $fileregex);
			$matchedfiles = array_merge($matchedfiles, $subdir_matches);
			unset($filename);
		}
		elseif (!is_dir("$location/$filename"))
		{
			list(, , , $description) = get_file_description("$location/$filename", $comment_max_caracters);
			$fileregex = str_replace("\*", " " , $fileregex);
			if ( (preg_match($fileregex,$description)) && (!eregi($rejectedfiles, $filename)) && (!eregi($reserved_files, $filename)) )
			{
				// Load description
				list($upl_user, , $filestatus) = get_file_description($filename, $comment_max_caracters);
				
				if(!$validation_enabled || $filestatus == VALIDATED || $upl_user == $logged_user_name || ($filestatus == UNVALIDATED && $grants[$user_status][VALIDATE]))
				{ array_push($matchedfiles,"$location/$filename"); }
			}
		}
	}
	closedir($all);
	unset($all);
	return $matchedfiles;
}

function findfile_byall($location='', $fileregex='')
{
	global $rejectedfiles, $comment_max_caracters, $contents, $grants, $user_status, $validation_enabled, $logged_user_name,$reserved_files;

	if (!$location || !is_dir($location) || !$fileregex)
	{
		return false;
	}

	$matchedfiles = array();

	$all = opendir($location);
	while ($filename = readdir($all))
	{
		if (is_dir("$location/$filename") && ($filename != "..") && ($filename != ".") && show_hidden_files($filename))
		{
			$subdir_matches = findfile_byall("$location/$filename", $fileregex);
			$matchedfiles = array_merge($matchedfiles, $subdir_matches);
			unset($filename);
		}
		elseif (!is_dir("$location/$filename"))
		{
			list($upl_user, , , $description) = get_file_description("$location/$filename", $comment_max_caracters);
			$fileregex = str_replace("\*", " " , $fileregex);
			if ( (preg_match($fileregex,$filename) || preg_match($fileregex,$upl_user) || preg_match($fileregex,$description)) && (!eregi($rejectedfiles, $filename)) && (!eregi($reserved_files, $filename)) )
			{
				// Load description
				list(, , $filestatus) = get_file_description($filename, $comment_max_caracters);
				
				if(!$validation_enabled || $filestatus == VALIDATED || $upl_user == $logged_user_name || ($filestatus == UNVALIDATED && $grants[$user_status][VALIDATE]))
				{ array_push($matchedfiles,"$location/$filename"); }
			}
		}
	}
	closedir($all);
	unset($all);
	return $matchedfiles;
}

function show_search_result_byfilename($string)
{
	global $phpExt, $tablecolor,$file_out_max_caracters;
	global $bordercolor, $font, $mess, $headercolor, $headerfontcolor, $normalfontcolor;
	global $grants, $user_status, $uploads_folder_name, $datetimeformat, $comment_max_caracters,$loc;

	// display search result table header

	echo "
<script language=\"javascript\" type=\"text/javascript\">
<!-- Begin
function popup(file, dir)
{
file=escape(file);
dir=escape(dir);
var fen=window.open('index.${phpExt}?action=view&filename='+file+'&directory='+dir+'&".SID."','filemanager','status=yes,scrollbars=yes,resizable=yes,width=700,height=550');
}
// End -->
</script>
     <table border=\"0\" width=\"90%\" bgcolor=\"$bordercolor\" cellpadding=\"4\" cellspacing=\"1\">
       <tr bgcolor=\"$headercolor\">";

	// Se abilitato mostro download
	if ($grants[$user_status][DOWNLOAD])
	{
		echo "
         <th align=\"right\" valign=\"middle\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[23]</b></font>
         </th>";
	}
	echo "
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[15]</b></font>
         </th>
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[48]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[17]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[18]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[19]</b></font>
         </th>
       </tr>\n";

	$search_result = findfile_byfilename($loc, '/'. addslashes($string).'/i');
	$desc = '';
	if (empty($search_result))
	{
		echo "
       <tr>
         <td colspan=\"6\" align=\"center\" bgcolor=\"$headercolor\">
           <font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[ALY03]</b></font>
         </td>
       </tr>";
	}
	else
	{
		foreach ($search_result as $filename)
		{
			$directory = ereg_replace($uploads_folder_name, '', dirname($filename));
			if (strchr($directory, '/') == 0)
			{ $directory = substr($directory, 1); }

			echo "
      <tr bgcolor=\"$tablecolor\" valign=\"top\">";

			// Se abilitato mostro download
			if ($grants[$user_status][DOWNLOAD])
			{
				echo "
          <td align=\"center\">
            <font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">
         <a href=\"index.${phpExt}?action=downloadfile&amp;filename=".basename($filename)."&amp;directory=".rawurlencode($directory)."&amp;".SID."\">
            <img src=\"images/download.gif\" alt=\"$mess[23]\" title=\"$mess[23]\"width=\"20\" height=\"20\" border=\"0\"></a>
         ".count_file_download($filename)."
         </font>
         </td>";
			}

			echo "
      <td align=\"left\" width=\"95%\">
        <table border=0>
            <tr>
           <td>
            <img src=\"images/".get_mimetype_img($filename)."\" align=\"middle\" border=\"0\" alt=\"".get_mimetype_img($filename)."\">
           </td>
          <td>
           <font face=\"$font\" size=\"2\" color=\"$normalfontcolor\">";
			if (is_viewable($filename))
			{ echo "<a href=\"index.${phpExt}?action=view&amp;filename=".rawurlencode($filename)."&amp;directory=".rawurlencode($directory)."\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"".allhtmlentities($filename)."\">"; }
			if (strlen(basename($filename)) <= $file_out_max_caracters)
			{ echo allhtmlentities(basename($filename)); }
			else
			{
				$path_parts = pathinfo($filename); // taken from 'functions.php'
				// makes sure that the max characters number is as it's set (number - dot - dot - extension)
				$file_out_max_characters = ($file_out_max_caracters-2) - strlen($path_parts["extension"]);
				// we need the filename without extension to cut only characters from there
				$name_without_extension = str_replace('.$path_parts["extension"]','',$path_parts["basename"]);
				// the second dot means: filename is shorted (shorted_part_of_filename..extension)
				echo allhtmlentities(substr($name_without_extension,0,$file_out_max_characters))."..".$path_parts["extension"];
			}
			if(is_viewable($filename))
			{ echo "</a>\n"; }
			// Load description
			list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description($filename, $comment_max_caracters);
			echo "
           </font><br>
           <font face=\"$font\" size=\"1\" color=\"$normalfontcolor\">$contents</font>
         </td>
        </tr>
      </table>
      </td>
      <td valign=\"middle\">
        <table border=0>
         <tr>
          <td>
           <img src=\"images/dossier.gif\" align=\"middle\" border=\"0\" alt=\"$mess[48]\" title=\"$mess[48]\">
          </td>
          <td align=\"left\" width=\"95%\" valign=\"middle\">
           <font size=\"2\" face=\"$font\" color=\"$normalfontcolor\">
           <a href=\"index.${phpExt}?directory=$directory&amp;".SID."\">Home/".substr($directory,0,12)."</a>
           </font>
          </td>
         </tr>
        </table>
      </td>
      <td align=\"right\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">".get_filesize($filename)."</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			$file_modif_time = filemtime($filename) - $timeoffset * 3600;
			echo date($datetimeformat, $file_modif_time);
			echo "</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			if ($user_status == ADMIN)
			{ // If admin, show IP
				if ($upl_user != "")
				{ echo "<b>$upl_user</b> - <b>$upl_ip</b>"; }
				else
				{ echo "<b>$upl_ip</b>"; }
			}
			else
			{
				if ($upl_user != "")
				{ echo    "<b><a href=\"profile.${phpExt}?username=$upl_user&".SID."\" title=\"$upl_user's profile\">$upl_user</a></b>"; }
			}
			echo "</font>
      </td>
    </tr>\n";
		}
	}
	echo "</table>";
}

function show_search_result_byauthor($string)
{
	global $phpExt, $tablecolor,$file_out_max_caracters;
	global $bordercolor, $font, $mess, $headercolor, $headerfontcolor, $normalfontcolor;
	global $grants, $user_status, $uploads_folder_name, $datetimeformat, $comment_max_caracters,$loc;

	// display search result table header

	echo "
<script language=\"javascript\" type=\"text/javascript\">
<!-- Begin
function popup(file, dir)
{
file=escape(file);
dir=escape(dir);
var fen=window.open('index.${phpExt}?action=view&filename='+file+'&directory='+dir+'&".SID."','filemanager','status=yes,scrollbars=yes,resizable=yes,width=700,height=550');
}
// End -->
</script>
     <table border=\"0\" width=\"90%\" bgcolor=\"$bordercolor\" cellpadding=\"4\" cellspacing=\"1\">
       <tr bgcolor=\"$headercolor\">";

	// Se abilitato mostro download
	if ($grants[$user_status][DOWNLOAD])
	{
		echo "
         <th align=\"right\" valign=\"middle\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[23]</b></font>
         </th>";
	}
	echo "
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[15]</b></font>
         </th>
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[48]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[17]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[18]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[19]</b></font>
         </th>
       </tr>\n";

	$search_result = findfile_byauthor($loc, '/'. addslashes($string).'/i');
	$desc = '';
	if (empty($search_result))
	{
		echo "
       <tr>
         <td colspan=\"6\" align=\"center\" bgcolor=\"$headercolor\">
           <font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[ALY03]</b></font>
         </td>
       </tr>";
	}
	else
	{
		foreach ($search_result as $filename)
		{
			$directory = ereg_replace($uploads_folder_name, '', dirname($filename));
			if (strchr($directory, '/') == 0)
			{ $directory = substr($directory, 1); }

			echo "
      <tr bgcolor=\"$tablecolor\" valign=\"top\">";

			// Se abilitato mostro download
			if ($grants[$user_status][DOWNLOAD])
			{
				echo "
          <td align=\"center\">
            <font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">
         <a href=\"index.${phpExt}?action=downloadfile&amp;filename=".basename($filename)."&amp;directory=".rawurlencode($directory)."&amp;".SID."\">
            <img src=\"images/download.gif\" alt=\"$mess[23]\" title=\"$mess[23]\"width=\"20\" height=\"20\" border=\"0\"></a>
         ".count_file_download($filename)."
         </font>
         </td>";
			}

			echo "
      <td align=\"left\" width=\"95%\">
        <table border=0>
            <tr>
           <td>
            <img src=\"images/".get_mimetype_img($filename)."\" align=\"middle\" border=\"0\" alt=\"".get_mimetype_img($filename)."\">
           </td>
          <td>
           <font face=\"$font\" size=\"2\" color=\"$normalfontcolor\">";
			if (is_viewable($filename))
			{ echo "<a href=\"index.${phpExt}?action=view&amp;filename=".rawurlencode($filename)."&amp;directory=".rawurlencode($directory)."\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"".allhtmlentities($filename)."\">"; }
			if (strlen(basename($filename)) <= $file_out_max_caracters)
			{ echo allhtmlentities(basename($filename)); }
			else
			{
				$path_parts = pathinfo($filename); // taken from 'functions.php'
				// makes sure that the max characters number is as it's set (number - dot - dot - extension)
				$file_out_max_characters = ($file_out_max_caracters-2) - strlen($path_parts["extension"]);
				// we need the filename without extension to cut only characters from there
				$name_without_extension = str_replace('.$path_parts["extension"]','',$path_parts["basename"]);
				// the second dot means: filename is shorted (shorted_part_of_filename..extension)
				echo allhtmlentities(substr($name_without_extension,0,$file_out_max_characters))."..".$path_parts["extension"];
			}
			if(is_viewable($filename))
			{ echo "</a>\n"; }
			// Load description
			list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description($filename, $comment_max_caracters);
			echo "
           </font><br>
           <font face=\"$font\" size=\"1\" color=\"$normalfontcolor\">$contents</font>
         </td>
        </tr>
      </table>
      </td>
      <td valign=\"middle\">
        <table border=0>
         <tr>
          <td>
           <img src=\"images/dossier.gif\" align=\"middle\" border=\"0\" alt=\"$mess[48]\" title=\"$mess[48]\">
          </td>
          <td align=\"left\" width=\"95%\" valign=\"middle\">
           <font size=\"2\" face=\"$font\" color=\"$normalfontcolor\">
           <a href=\"index.${phpExt}?directory=$directory&amp;".SID."\">Home/".substr($directory,0,12)."</a>
           </font>
          </td>
         </tr>
        </table>
      </td>
      <td align=\"right\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">".get_filesize($filename)."</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			$file_modif_time = filemtime($filename) - $timeoffset * 3600;
			echo date($datetimeformat, $file_modif_time);
			echo "</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			if ($user_status == ADMIN)
			{ // If admin, show IP
				if ($upl_user != "")
				{ echo "<b>$upl_user</b> - <b>$upl_ip</b>"; }
				else
				{ echo "<b>$upl_ip</b>"; }
			}
			else
			{
				if ($upl_user != "")
				{ echo    "<b><a href=\"profile.${phpExt}?username=$upl_user&".SID."\" title=\"$upl_user's profile\">$upl_user</a></b>"; }
			}
			echo "</font>
      </td>
    </tr>\n";
		}
	}
	echo "</table>";
}

function show_search_result_bydesc($string)
{
	global $phpExt, $tablecolor,$file_out_max_caracters;
	global $bordercolor, $font, $mess, $headercolor, $headerfontcolor, $normalfontcolor;
	global $grants, $user_status, $uploads_folder_name, $datetimeformat, $comment_max_caracters,$loc;

	// display search result table header

	echo "
<script language=\"javascript\" type=\"text/javascript\">
<!-- Begin
function popup(file, dir)
{
file=escape(file);
dir=escape(dir);
var fen=window.open('index.${phpExt}?action=view&filename='+file+'&directory='+dir+'&".SID."','filemanager','status=yes,scrollbars=yes,resizable=yes,width=700,height=550');
}
// End -->
</script>
     <table border=\"0\" width=\"90%\" bgcolor=\"$bordercolor\" cellpadding=\"4\" cellspacing=\"1\">
       <tr bgcolor=\"$headercolor\">";

	// Se abilitato mostro download
	if ($grants[$user_status][DOWNLOAD])
	{
		echo "
         <th align=\"right\" valign=\"middle\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[23]</b></font>
         </th>";
	}
	echo "
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[15]</b></font>
         </th>
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[48]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[17]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[18]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[19]</b></font>
         </th>
       </tr>\n";

	$search_result = findfile_bydesc($loc, '/'. addslashes($string).'/i');
	$desc = '';
	if (empty($search_result))
	{
		echo "
       <tr>
         <td colspan=\"6\" align=\"center\" bgcolor=\"$headercolor\">
           <font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[ALY03]</b></font>
         </td>
       </tr>";
	}
	else
	{
		foreach ($search_result as $filename)
		{
			$directory = ereg_replace($uploads_folder_name, '', dirname($filename));
			if (strchr($directory, '/') == 0)
			{ $directory = substr($directory, 1); }

			echo "
      <tr bgcolor=\"$tablecolor\" valign=\"top\">";

			// Se abilitato mostro download
			if ($grants[$user_status][DOWNLOAD])
			{
				echo "
          <td align=\"center\">
            <font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">
         <a href=\"index.${phpExt}?action=downloadfile&amp;filename=".basename($filename)."&amp;directory=".rawurlencode($directory)."&amp;".SID."\">
            <img src=\"images/download.gif\" alt=\"$mess[23]\" title=\"$mess[23]\"width=\"20\" height=\"20\" border=\"0\"></a>
         ".count_file_download($filename)."
         </font>
         </td>";
			}

			echo "
      <td align=\"left\" width=\"95%\">
        <table border=0>
            <tr>
           <td>
            <img src=\"images/".get_mimetype_img($filename)."\" align=\"middle\" border=\"0\" alt=\"".get_mimetype_img($filename)."\">
           </td>
          <td>
           <font face=\"$font\" size=\"2\" color=\"$normalfontcolor\">";
			if (is_viewable($filename))
			{ echo "<a href=\"index.${phpExt}?action=view&amp;filename=".rawurlencode($filename)."&amp;directory=".rawurlencode($directory)."\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"".allhtmlentities($filename)."\">"; }
			if (strlen(basename($filename)) <= $file_out_max_caracters)
			{ echo allhtmlentities(basename($filename)); }
			else
			{
				$path_parts = pathinfo($filename); // taken from 'functions.php'
				// makes sure that the max characters number is as it's set (number - dot - dot - extension)
				$file_out_max_characters = ($file_out_max_caracters-2) - strlen($path_parts["extension"]);
				// we need the filename without extension to cut only characters from there
				$name_without_extension = str_replace('.$path_parts["extension"]','',$path_parts["basename"]);
				// the second dot means: filename is shorted (shorted_part_of_filename..extension)
				echo allhtmlentities(substr($name_without_extension,0,$file_out_max_characters))."..".$path_parts["extension"];
			}
			if(is_viewable($filename))
			{ echo "</a>\n"; }
			// Load description
			list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description($filename, $comment_max_caracters);
			echo "
           </font><br>
           <font face=\"$font\" size=\"1\" color=\"$normalfontcolor\">$contents</font>
         </td>
        </tr>
      </table>
      </td>
      <td valign=\"middle\">
        <table border=0>
         <tr>
          <td>
           <img src=\"images/dossier.gif\" align=\"middle\" border=\"0\" alt=\"$mess[48]\" title=\"$mess[48]\">
          </td>
          <td align=\"left\" width=\"95%\" valign=\"middle\">
           <font size=\"2\" face=\"$font\" color=\"$normalfontcolor\">
           <a href=\"index.${phpExt}?directory=$directory&amp;".SID."\">Home/".substr($directory,0,12)."</a>
           </font>
          </td>
         </tr>
        </table>
      </td>
      <td align=\"right\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">".get_filesize($filename)."</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			$file_modif_time = filemtime($filename) - $timeoffset * 3600;
			echo date($datetimeformat, $file_modif_time);
			echo "</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			if ($user_status == ADMIN)
			{ // If admin, show IP
				if ($upl_user != "")
				{ echo "<b>$upl_user</b> - <b>$upl_ip</b>"; }
				else
				{ echo "<b>$upl_ip</b>"; }
			}
			else
			{
				if ($upl_user != "")
				{ echo    "<b><a href=\"profile.${phpExt}?username=$upl_user&".SID."\" title=\"$upl_user's profile\">$upl_user</a></b>"; }
			}
			echo "</font>
      </td>
    </tr>\n";
		}
	}
	echo "</table>";
}

function show_search_result_byall($string)
{
	global $phpExt, $tablecolor,$file_out_max_caracters;
	global $bordercolor, $font, $mess, $headercolor, $headerfontcolor, $normalfontcolor;
	global $grants, $user_status, $uploads_folder_name, $datetimeformat, $comment_max_caracters,$loc;

	// display search result table header

	echo "
<script language=\"javascript\" type=\"text/javascript\">
<!-- Begin
function popup(file, dir)
{
file=escape(file);
dir=escape(dir);
var fen=window.open('index.${phpExt}?action=view&filename='+file+'&directory='+dir+'&".SID."','filemanager','status=yes,scrollbars=yes,resizable=yes,width=700,height=550');
}
// End -->
</script>
     <table border=\"0\" width=\"90%\" bgcolor=\"$bordercolor\" cellpadding=\"4\" cellspacing=\"1\">
       <tr bgcolor=\"$headercolor\">";

	// Se abilitato mostro download
	if ($grants[$user_status][DOWNLOAD])
	{
		echo "
         <th align=\"right\" valign=\"middle\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[23]</b></font>
         </th>";
	}
	echo "
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[15]</b></font>
         </th>
         <th align=\"left\" valign=\"middle\" width=\"95%\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[48]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[17]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[18]</b></font>
         </th>
         <th align=\"center\" valign=\"middle\" width=\"95%\" style=\"white-space: nowrap\">
           <font face=\"$font\" size=\"2\" color=\"$headerfontcolor\"><b>$mess[19]</b></font>
         </th>
       </tr>\n";

   $search_result = findfile_byall($loc, '/'. addslashes($string).'/i');
   $desc = '';
	if (empty($search_result))
	{
		echo "
       <tr>
         <td colspan=\"6\" align=\"center\" bgcolor=\"$headercolor\">
           <font color=\"$headerfontcolor\" face=\"$font\" size=\"2\"><b>$mess[ALY03]</b></font>
         </td>
       </tr>";
	}
	else
	{
		foreach ($search_result as $filename)
		{
			$directory = ereg_replace($uploads_folder_name, '', dirname($filename));
			if (strchr($directory, '/') == 0)
			{ $directory = substr($directory, 1); }

			echo "
      <tr bgcolor=\"$tablecolor\" valign=\"top\">";

			// Se abilitato mostro download
			if ($grants[$user_status][DOWNLOAD])
			{
				echo "
          <td align=\"center\">
            <font size=\"1\" face=\"$font\" color=\"$normalfontcolor\">
         <a href=\"index.${phpExt}?action=downloadfile&amp;filename=".basename($filename)."&amp;directory=".rawurlencode($directory)."&amp;".SID."\">
            <img src=\"images/download.gif\" alt=\"$mess[23]\" title=\"$mess[23]\"width=\"20\" height=\"20\" border=\"0\"></a>
         ".count_file_download($filename)."
         </font>
         </td>";
			}

			echo "
      <td align=\"left\" width=\"95%\">
        <table border=0>
            <tr>
           <td>
            <img src=\"images/".get_mimetype_img($filename)."\" align=\"middle\" border=\"0\" alt=\"".get_mimetype_img($filename)."\">
           </td>
          <td>
           <font face=\"$font\" size=\"2\" color=\"$normalfontcolor\">";
			if (is_viewable($filename))
			{ echo "<a href=\"index.${phpExt}?action=view&amp;filename=".rawurlencode($filename)."&amp;directory=".rawurlencode($directory)."\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"".allhtmlentities($filename)."\">"; }
			if (strlen(basename($filename)) <= $file_out_max_caracters)
			{ echo allhtmlentities(basename($filename)); }
			else
			{
				$path_parts = pathinfo($filename); // taken from 'functions.php'
				// makes sure that the max characters number is as it's set (number - dot - dot - extension)
				$file_out_max_characters = ($file_out_max_caracters-2) - strlen($path_parts["extension"]);
				// we need the filename without extension to cut only characters from there
				$name_without_extension = str_replace('.$path_parts["extension"]','',$path_parts["basename"]);
				// the second dot means: filename is shorted (shorted_part_of_filename..extension)
				echo allhtmlentities(substr($name_without_extension,0,$file_out_max_characters))."..".$path_parts["extension"];
			}
			if(is_viewable($filename))
			{ echo "</a>\n"; }
			// Load description
			list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description($filename, $comment_max_caracters);
			echo "
           </font><br>
           <font face=\"$font\" size=\"1\" color=\"$normalfontcolor\">$contents</font>
         </td>
        </tr>
      </table>
      </td>
      <td valign=\"middle\">
        <table border=0>
         <tr>
          <td>
           <img src=\"images/dossier.gif\" align=\"middle\" border=\"0\" alt=\"$mess[48]\" title=\"$mess[48]\">
          </td>
          <td align=\"left\" width=\"95%\" valign=\"middle\">
           <font size=\"2\" face=\"$font\" color=\"$normalfontcolor\">
           <a href=\"index.${phpExt}?directory=$directory&amp;".SID."\">Home/".substr($directory,0,12)."</a>
           </font>
          </td>
         </tr>
        </table>
      </td>
      <td align=\"right\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">".get_filesize($filename)."</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\" style=\"white-space: nowrap\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			$file_modif_time = filemtime($filename) - $timeoffset * 3600;
			echo date($datetimeformat, $file_modif_time);
			echo "</font>
      </td>
      <td align=\"left\" width=\"95%\" valign=\"middle\">
        <font size=\"1\" color=\"$normalfontcolor\" face=\"$font\">";
			if ($user_status == ADMIN)
			{ // If admin, show IP
				if ($upl_user != "")
				{ echo "<b>$upl_user</b> - <b>$upl_ip</b>"; }
				else
				{ echo "<b>$upl_ip</b>"; }
			}
			else
			{
				if ($upl_user != "")
				{ echo    "<b><a href=\"profile.${phpExt}?username=$upl_user&".SID."\" title=\"$upl_user's profile\">$upl_user</a></b>"; }
			}
			echo "</font>
      </td>
    </tr>\n";
		}
	}
	echo "</table>";
}

//----------------------------------------------------------------------------
//      MAIN
//----------------------------------------------------------------------------
if (!$grants[$user_status][VIEW])
{
	header($header_location.'index.'.$phpExt.'?'.SID);
	exit;
}

$str = getPostVar("q");
$loc = getPostVar("loc");

switch($action)
{

	case 'showsearchresults_byfilename';
		place_header($mess[ALY02]." by filename: $str");
		show_search_result_byfilename($str);
		break;

	case 'showsearchresults_byauthor';
		place_header($mess[ALY02]." by author: $str");
		show_search_result_byauthor($str);
		break;

	case 'showsearchresults_bydesc';
		place_header($mess[ALY02]." by description: $str");
		show_search_result_bydesc($str);
		break;

	case 'showsearchresults_byall';
		place_header($mess[ALY02]." by filename, author &amp; description: $str");
		show_search_result_byall($str);
		break;

	default:
	header($header_location.'index.'.$phpExt.'?'.SID);
	exit;
}

show_footer_page();
?>